"""Naval Fate.

Usage:
  git-cloner clon [(-u <user> | --user=<user>) [(-p <pass>| --pass=<pass>)]] [(-f | --force)] [(-V | --verbose)] [(-o <out>| --out=<out>)]
                  [(-r <file>| --retry=<file>)] ((-c <org> | --org=<org>) | (--U <user> | --target-user=<user>))
                  (-t <type> | --type=<type>)
                  [(-s <file> | --save=<file>)] [--ssh]
  git-cloner make-repos [(-u <user> | --user=<user>)] [-f] [(-i <in>| --in=<in>)] [(-s <file> | --save=<file>)]
                  (-t <type> | --type=<type>) --priv-token=<token> (-h | --host=<host>) [--ssh]
  git-cloner (-h | --help)
  git-cloner --version

Options:
  -l --limit=<limit>      Limit of repositories
  -u --user=<user>        User to connect
  -p --pass=<pass>    Password to connect. The prompt ask if it is not provided
  -v --version            Show version.
  -V --verbose            Show version.
  -c --org=<org>          Origin (organization) to read repositories. It is incompatible with target-user
  -h --help               Show help
  -f --force              Force remove directories
  -o --out=<out>          Output directory
  -i --in=<in>            Input directory
  -s --save=<file>        Save Output result into a file
  -r --retry=<file>       Retry the for the last execution, the input is te save file from the previous execution
  --ssh                   Use ssh instead https
  -t --type=<type>        Indicate the type of repository gitlab is only supported jet
  -U --target-user=<user> Origin (user) to read repositories. It is incompatible with org
  --priv-token=<token>    Indicate the path to the private token where the token is
  -H --host=<host>        Indicate the host. i.e git@gitlab.com:4123


"""

from docopt import docopt

from git_cloner.operations.mass_cloner import mass_cloner
from git_cloner.utils.logger import get_logger_console
from git_cloner.utils.utils import *


def main():
    arguments = docopt(__doc__, version='Git cloner {version}'.format(version='1.1.0-SNAPSHOT'))
    run(arguments)


logger = get_logger_console(__name__)


def run(arguments):
    logger.debug(arguments)
    Config.load_config(arguments)
    if arguments['clon']:
        mass_cloner()
        # repos = list_repos(Config.get_config().org, Config.get_config().limit)
        # clones(repos)


if __name__ == '__main__':
    main()
