import os
from pathlib import Path
from uuid import uuid4

from git_cloner import structure_repo
from git_cloner.utils.config import Config


def add_remote():
    current_dir = Path.cwd()
    remote = uuid4()
    cmd_remote_add = "git remote add {remote} git://git@{host}/{org}/{name}".format(
        name=current_dir.name,
        remote=remote,
        host=Config.get_config().host,
        org=Config.get_config().org

    )
    print(cmd_remote_add)
    return remote


def delete_remote(remote):
    cmd_remote_remove = "git remote remove {remote}".format(remote=remote)
    print(cmd_remote_remove)


def push_all(remote):
    cmd_push = "git push --all {remote}".format(remote=remote)
    print(cmd_push)


def get_namespace():
    org = Config.get_config().org
    url = "http://git.fhuertas.com:55080/api/v3/namespaces"
    headers = {'PRIVATE-TOKEN': Config.get_config().token}
    r = [{'id': 4, 'name': 'stratio', 'path': 'stratio', 'kind': 'group', 'full_path': 'stratio', 'parent_id': None,
          'members_count_with_descendants': 1},
         {'id': 3, 'name': 'personal', 'path': 'personal', 'kind': 'group', 'full_path': 'personal', 'parent_id': None,
          'members_count_with_descendants': 1},
         {'id': 2, 'name': 'fhuertas', 'path': 'fhuertas', 'kind': 'user', 'full_path': 'fhuertas', 'parent_id': None},
         {'id': 1, 'name': 'root', 'path': 'root', 'kind': 'user', 'full_path': 'root', 'parent_id': None}]
    # r = requests.get(url, headers=headers)
    result = [e for e in r if e.get('name') == Config.get_config().org]
    if len(result) > 0:
        return result[0].get('id')
    return -1


def create_repo(ns):
    current_dir = Path.cwd()
    cmd = 'curl --header "PRIVATE-TOKEN: {token}" -X POST "http://git.fhuertas.com:55080/api/v3/projects?name={' \
          'name}&namespace_id={ns}"'.format(ns=ns, token=Config.get_config().token, name=current_dir.name)
    print(cmd)


def push_repository(path, ns):
    print("XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXxx")
    current_dir = Path.cwd()
    os.chdir(path)
    print(Path.cwd())
    remote = add_remote()
    push_all(remote)
    create_repo(ns)
    delete_remote(remote)
    # print(ns)

    os.chdir(str(current_dir))
    pass


def make_all():
    path = Config.get_config().dir_in
    ns = get_namespace()
    print("NAMESPACE {}".format(ns))
    dirs = structure_repo.list_repos(path)
    [push_repository(path, ns) for path in dirs]


class GitlabWrapper(object):
    pass
