from uuid import uuid4

from git_cloner.model.remotes.remote import Remote


class GitlabRemote(Remote):
    SSH_URL_BASE = "ssh://git@{host}/{owner}/{repo}"
    HTTP_URL_BASE = "http://{host}/{owner}/{repo}"
    HTTPS_URL_BASE = "https://{host}/{owner}/{repo}"

    def __init__(self, host, owner, repo_name, remote_type, name=uuid4()):
        self.name = name
        self.host = host
        self.owner = owner
        self.repo_name = repo_name
        self.type = remote_type

    def get_name(self):
        return self.name

    def get_host(self):
        return self.host

    def get_owner(self):
        return self.owner

    def build_remote_url(self):
        return {
            'ssh': self.SSH_URL_BASE.format(host=self.host, owner=self.owner, repo=self.repo_name),
            'http': self.HTTP_URL_BASE.format(host=self.host, owner=self.owner, repo=self.repo_name),
            'https': self.HTTPS_URL_BASE.format(host=self.host, owner=self.owner, repo=self.repo_name),
        }.get(self.type)
