import json

from git_cloner.model.owner.owner import Owner
from git_cloner.model.repository import RawRepository
from git_cloner.utils.config import Config


def mass_cloner():
    out = Config.get_config().dir_out
    repos = get_repos()
    results = [repo.clone(out) for repo in repos]
    return [result for result in results if result is not None]


def get_repos():
    if Config.get_config().retry is None:
        owner = Owner.builder(Config.get_config().type)
        return owner.get_repos()
    return log_retry_path(Config.get_config().retry)


def log_retry_path(path):
    template_dic = """{{"name": "{name}","owner": {{"login": "{login}"}}}}"""
    with open(path) as file:
        lines = [line.strip() for line in file.readlines()]
        filtered = [line for line in lines if line.endswith("False")]
        format_str = [template_dic.format(
            name=line.split(",")[0].split(":")[1].split("/")[1].strip(),
            login=line.split(",")[0].split(":")[1].split("/")[0].strip())
            for line in filtered]
        return [RawRepository(json.loads(line)) for line in format_str]
