import os
import subprocess
from pathlib import Path


def list_repos(path):
    paths = [Path(path).joinpath(e) for e in os.listdir(path)]
    return [str(x) for x in paths if check_git_dir(x)]


def check_git_dir(path):
    cmd = "git -C {} rev-parse".format(path)
    return subprocess.run(cmd.split(" "), stdout=subprocess.PIPE, stderr=subprocess.PIPE).returncode == 0
