import logging

from git_cloner.utils.config import Config


def get_logger_console(origin_module,
                       str_format='%(asctime)s %(name)-12s %(levelname)-8s %(message)s',
                       date_format='%m-%d %H:%M'):
    level = logging.DEBUG if Config.get_config().verbose else logging.INFO
    logging.basicConfig(
        level=level,
        format=str_format,
        datefmt=date_format)
    logger_name = origin_module if isinstance(origin_module, str) else origin_module.__module__
    return logging.getLogger(logger_name)


def log_result(remote, operation, result):
    template = "\nRepo: {}/{}, Operation: {}, Result: {}"
    if Config.get_config().save is not None:
        with open(Config.get_config().save, "a") as my_file:
            my_file.write(template.format(remote.owner, remote.repo_name, operation, result))
