"""{"--force": False,
 "--help": False,
 "--host": None,
 "--in": None,
 "--org": "stratio",
 "--out": None,
 "--priv-token": None,
 "--retry": None,
 "--save": None,
 "--ssh": True,
 "--type": "github",
 "--user": None,
 "--verbose": False,
 "--version": False,
 "clon": True,
 "make-repos": False}"""
import unittest
import runpy

import sys

from git_cloner.boot import boot
from git_cloner.utils.utils import read
from tests.git_cloner.utils.utils import *
from pkg_resources import resource_filename

test_dir = "/tmp/test_tmp"

secrets_path = os.path.join(resource_filename('tests', 'resources'), 'secrets')


class BootAT(unittest.TestCase):
    def setUp(self):
        self.old_dir = set_test_dir(test_dir)
        self.args = sys.argv

    def tearDown(self):
        sys.argv = self.args
        restore_path(self.old_dir)

    # Command: git-cloner clon -u user -p pass -U yunxao --ssh -t github -o /tmp/test_tmp/fhuertas -s /tmp/test_tmp/log.log
    def test_run_clone_at(self):
        print("Command")
        print("git-cloner clon -u user -p pass -U yunxao --ssh -t github -o /tmp/test_tmp/fhuertas "
              "-s /tmp/test_tmp/log.log")
        user = read(os.path.join(secrets_path, 'user'))
        password = read(os.path.join(secrets_path, 'password'))
        cmd = "git-cloner clon -u {user} -p {password} -U yunxao --ssh -t github -o {out_dir}/fhuertas " \
              "-s {out_dir}/log.log".format(out_dir=test_dir, user=user, password=password)
        sys.argv = cmd.split(" ")
        runpy.run_module(boot.__name__, run_name="__main__", alter_sys=False)
        with open(os.path.join(test_dir, "log.log")) as file:
            lines = len([line for line in file.readlines() if line.strip() != ""])
            self.assertEqual(lines, 10)
