import unittest

from git_cloner.model.owner.github_owner import GithubOwner
from git_cloner.model.owner.owner import Owner
from git_cloner.utils.config import Config


class OwnerTest(unittest.TestCase):
    def test_builder_github(self):
        Config.load_config({}).target_user = "pepe"
        result = Owner.builder("github")
        self.assertEqual(result.owner, "pepe")
        self.assertEqual(result.is_user, True)
        self.assertTrue(isinstance(result, GithubOwner))

    def test_builder_other(self):
        self.assertRaises(RuntimeError, Owner.builder, "invalid")
        pass
