from random import *

names = ['passenger', 'nod', 'pick', 'teeth', 'explain', 'disgusting', 'mix', 'film', 'worry', 'lewd',
         'agreeable', 'rub', 'tan', 'suppose', 'waste', 'paddle', 'optimal', 'belief', 'cakes', 'meat',
         'shadingo']


def gen_name():
    pos = randrange(0, len(names))
    return names[pos]


def gen_int(start=0, limit=1000000):
    return randrange(start, limit)


def gen_bool():
    return bool(randrange(0, 2))


def join_path(path1, path2): return "{}/{}".format(path1, path2)


def gen_github_ssh_url():
    pass


def generate_repo_github(name=gen_name(), user=gen_name()):
    full_path = join_path(user, name)
    description = [gen_name() for _ in range(gen_int(limit=100))]
    api_url_base_repos = join_path("https://api.github.com/repos", full_path)
    api_user_base = join_path("https://api.github.com/users", user)
    repo_base_url = join_path("https://github.com", full_path)
    return {
        "id": gen_int(),
        "name": name,
        "full_name": full_path,
        "owner": {
            "login": user,
            "id": gen_int(),
            "avatar_url": "https://avatars0.githubusercontent.com/u/5879698?v=4",
            "gravatar_id": "",
            "url": api_user_base,
            "html_url": "https://github.com/{user}".format(user=user),
            "followers_url": join_path(api_user_base, "/followers"),
            "following_url": join_path(api_user_base, "/following{/other_user}"),
            "gists_url": join_path(api_user_base, "/gists{/gist_id}"),
            "starred_url": join_path(api_user_base, "/starred{/owner}{/repo}"),
            "subscriptions_url": join_path(api_user_base, "/subscriptions"),
            "organizations_url": join_path(api_user_base, "/orgs"),
            "repos_url": join_path(api_user_base, "/repos"),
            "events_url": join_path(api_user_base, "/events{/privacy}"),
            "received_events_url": join_path(api_user_base, "/received_events"),
            "type": "User",
            "site_admin": gen_bool()
        },
        "private": gen_bool(),
        "html_url": repo_base_url,
        "description": description,
        "fork": gen_bool(),
        "url": api_url_base_repos,
        "forks_url": join_path(api_url_base_repos, "/forks"),
        "keys_url": join_path(api_url_base_repos, "/keys{/key_id}"),
        "collaborators_url": join_path(api_url_base_repos, "/collaborators{/collaborator}"),
        "teams_url": join_path(api_url_base_repos, "/teams"),
        "hooks_url": join_path(api_url_base_repos, "/hooks"),
        "issue_events_url": join_path(api_url_base_repos, "/issues/events{/number}"),
        "events_url": join_path(api_url_base_repos, "/events"),
        "assignees_url": join_path(api_url_base_repos, "/assignees{/user}"),
        "branches_url": join_path(api_url_base_repos, "/branches{/branch}"),
        "tags_url": join_path(api_url_base_repos, "/tags"),
        "blobs_url": join_path(api_url_base_repos, "/git/blobs{/sha}"),
        "git_tags_url": join_path(api_url_base_repos, "/git/tags{/sha}"),
        "git_refs_url": join_path(api_url_base_repos, "/git/refs{/sha}"),
        "trees_url": join_path(api_url_base_repos, "/git/trees{/sha}"),
        "statuses_url": join_path(api_url_base_repos, "/statuses/{sha}"),
        "languages_url": join_path(api_url_base_repos, "/languages"),
        "stargazers_url": join_path(api_url_base_repos, "/stargazers"),
        "contributors_url": join_path(api_url_base_repos, "/contributors"),
        "subscribers_url": join_path(api_url_base_repos, "/subscribers"),
        "subscription_url": join_path(api_url_base_repos, "/subscription"),
        "commits_url": join_path(api_url_base_repos, "/commits{/sha}"),
        "git_commits_url": join_path(api_url_base_repos, "/git/commits{/sha}"),
        "comments_url": join_path(api_url_base_repos, "/comments{/number}"),
        "issue_comment_url": join_path(api_url_base_repos, "/issues/comments{/number}"),
        "contents_url": join_path(api_url_base_repos, "/contents/{+path}"),
        "compare_url": join_path(api_url_base_repos, "/compare/{base}...{head}"),
        "merges_url": join_path(api_url_base_repos, "/merges"),
        "archive_url": join_path(api_url_base_repos, "/{archive_format}{/ref}"),
        "downloads_url": join_path(api_url_base_repos, "/downloads"),
        "issues_url": join_path(api_url_base_repos, "/issues{/number}"),
        "pulls_url": join_path(api_url_base_repos, "/pulls{/number}"),
        "milestones_url": join_path(api_url_base_repos, "/milestones{/number}"),
        "notifications_url": join_path(api_url_base_repos, "/notifications{?since,all,participating}"),
        "labels_url": join_path(api_url_base_repos, "/labels{/name}"),
        "releases_url": join_path(api_url_base_repos, "/releases{/id}"),
        "deployments_url": join_path(api_url_base_repos, "/deployments"),
        "created_at": "2017-05-04T06:30:53Z",
        "updated_at": "2017-05-05T14:02:57Z",
        "pushed_at": "2017-05-05T14:02:56Z",
        "git_url": "git://github.com/{}.git".format(full_path),
        "ssh_url": "git@github.com:{}.git".format(full_path),
        "clone_url": join_path(repo_base_url, ".git"),
        "svn_url": repo_base_url,
        "homepage": None,
        "size": gen_int(),
        "stargazers_count": 0,
        "watchers_count": 0,
        "language": "Shell",
        "has_issues": gen_bool(),
        "has_projects": gen_bool(),
        "has_downloads": gen_bool(),
        "has_wiki": gen_bool(),
        "has_pages": gen_bool(),
        "forks_count": 0,
        "mirror_url": None,
        "archived": gen_bool(),
        "open_issues_count": 0,
        "forks": 0,
        "open_issues": 0,
        "watchers": 0,
        "default_branch": "master"
    }
