import unittest

from pkg_resources import *

from git_cloner.utils.utils import *

secrets_path = os.path.join(resource_filename('tests', 'resources'), 'secrets')


class UtilsTest(unittest.TestCase):
    def make_curl_with_auth_incorrect_it(self):
        auth_url = "https://api.github.com"
        config = Config.load_config({})
        config.user = "invalid"
        config.password = "invalid"
        self.assertRaises(RuntimeError, make_request, auth_url)

    def make_curl_with_auth_valid_it(self):
        auth_url = "https://api.github.com"
        config = Config.load_config({})
        config.user = read(secrets_path + '/user')
        config.password = read(secrets_path + '/password')
        result = make_request(auth_url)
        self.assertEqual(result.get('current_user_url'), "https://api.github.com/user")

    def make_curl_with_no_auth_it(self):
        auth_url = "https://api.github.com"
        Config.load_config({})
        result = make_request(auth_url)
        self.assertEqual(result.get('current_user_url'), "https://api.github.com/user")
